#include "mpi.h"

int worker( argc, argv )
int argc;
char **argv;
{
    MPI_HANDLE       handle;
    MPI_DATATYPE     datatype;
    int              source_dest;
    int              tag;
    MPI_COMMUNICATOR comm;
    MPI_MODE         op_mode;
    MPI_PERSISTENCE  persistence;
    int              rank;

    MPI_Init( &argc, argv );

    MPI_Comm_Rank( (MPI_COMMUNICATOR) MPI_COMM_WORLD, &rank );

    printf("my rank is %d\n", rank);

    /* do an isend */
    printf("isending....\n");
    datatype    = MPI_FLOAT;
    source_dest = 1;
    tag         = 100;
    comm        = MPI_COMM_WORLD;
    op_mode     = MPI_STANDARD;
    persistence = MPI_PERSISTENT;
    MPI_Comm_Init( &handle, datatype, source_dest,
		  tag, comm, op_mode, persistence);
    MPIR_dump_shandle( *handle );
    MPI_Start( handle );
    MPI_Comm_Free(handle);
    
    /* do an irecv */
    printf("ireceiving....\n");
    datatype    = MPI_INT;
    source_dest = 0;
    tag         = 200;
    comm        = MPI_COMM_WORLD;
    op_mode     = MPI_RECV;
    persistence = MPI_EPHEMERAL;
    MPI_Comm_Init( &handle, datatype, source_dest,
		  tag, comm, op_mode, persistence );
    MPIR_dump_rhandle( *handle );
    MPI_Start( handle );
    MPI_Comm_Free( handle );

    MPI_Finalize();
}
